#!/usr/bin/perl -w

# Moblin Application Checker
# About Page Module (tests_about.pl)
#
# Copyright (C) 2007-2009 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# version 2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Templates;

print "HTTP/1.0 200 OK\n";
print "Content-type: text/html\n\n";

print_header("About Moblin Application Checker", "about");
my $utils_dir_esc = escape_path($CONFIG{'UTILS_DIR'});
my $ver = (`cat $utils_dir_esc/VERSION 2>/dev/null` or 'undefined');
$ver =~ s/[\r\n]//g;

my $arch = guess_test_arch($CONFIG{'TESTS_DIR'}.'/moblinappchk');
if ($arch ne 'unknown') {
	$arch = " for $arch";
}
else {
	$arch = '';
}

print <<DATA;
<div style="width: 54em;">
<h1>Moblin Application Checker</h1>
<p>
<b>Version $ver$arch</b>
</p>
<p>Copyright &copy; 2007&ndash;2009 <a href="http://linuxfoundation.org" target="_blank">The Linux Foundation</a>. All rights reserved.</p>

<h2>Product Support</h2>
<p>Should you have any questions, comments or feature requests, please contact the <a href="mailto:lsb-appcheck-support\@linuxfoundation.org">support team</a>. You can also use the project <a href="http://ispras.linuxfoundation.org/index.php/About_Moblin_Application_Checker" target="_blank">home page</a> for more information about the Moblin Application Checker.</p>

<h2>License</h2>
<p>This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License version 2 as published by the Free Software Foundation.</p>

<p>This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.</p>

<p>You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.</p>
</div>
DATA

print_footer();
