#!/usr/bin/perl -w

# Moblin Application Checker
# Administration Page Module (tests_admin.pl)
#
# Copyright (C) 2007-2009 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# version 2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Templates;
use Fcntl ':flock';

print "HTTP/1.0 200 OK\n";
print "Content-type: text/html\n\n";

print_header('Moblin Application Checker Administration', 'admin');

print "<h1>Moblin Application Checker Administration</h1>\n";

print show_error_dlg('');

my $log_file = "$SERVER_PARAM{'APP_DATA'}/log/app-checker-server.log.$SERVER_PARAM{'PORT'}";
my $serv_pid = $SERVER_PARAM{'SERVER_PID'};

my $serv_status;
my $serv_stop_button;
if ($serv_pid) {
	$serv_status = "<font color=\"green\">Running</font> (PID: $serv_pid)";
	$serv_stop_button = " onclick=\"javascript:onStopServer($serv_pid, 'server');\"";
}
else {
	$serv_status = '<b><font color="red">PID not found!</font></b>';
	$serv_stop_button = ' disabled="disabled"';
}

print <<DATA;
<div id="ajax_loading" style="display: none; position: fixed; width: 13em; height: 5.8em; top: 40%; left: 50%; margin-top: -2.9em; margin-left: -7.5em; border: solid 1px #00007f; background-color: #e7f0ff; text-align: center; padding: 6px;"><div align="center">
Please wait&hellip;<br />
<img src="images/environment-spacer.gif" width="1" height="5" alt="" /><br />
<img src="images/ajax_progress.gif" width="16" height="16" alt="" /><br />
<img src="images/environment-spacer.gif" width="1" height="7" alt="" /><br />
<input type="button" name="ajax_abort" id="ajax_abort" value="Abort" style="border: solid 1px #00007f; background: #e0e0ff; color: blue; width: 6em;" onclick="javascript:onAbort();" />
</div></div>

<div id="ajax_loading2" style="display: none; position: fixed; width: 32em; height: 7.8em; top: 40%; left: 50%; margin-top: -3.9em; margin-left: -16em; border: solid 1px #00007f; background-color: #e7f0ff; text-align: center; padding: 6px;"><div align="center">
<table cellpadding="0" cellspacing="0" border="0" style="width: 400px;"><tr>
  <td align="left" width="100%" style="white-space: nowrap;">Downloading: <span id="db_upd_filename"></span></td>
  <td align="right" style="white-space: nowrap;">Time elapsed: <span id="timer" style="font-family: monospace; color: blue;">00:00</span></td>
</tr></table>
<img src="images/environment-spacer.gif" width="1" height="6" alt="" /><br />
<div style="width: 400px; height: 12px; border: 1px solid #004000; text-align: left;"><img src="images/progress.png" alt="progress: 0/0" width="0" height="12" id="db_upd_progress_bar_file" style="display: none;" /></div>
<div style="height: 12px;"></div>
<div style="width: 400px; height: 12px; border: 1px solid #004000; text-align: left;"><img src="images/progress.png" alt="progress: 0/0" width="0" height="12" id="db_upd_progress_bar_total" style="display: none;" /></div>
<img src="images/environment-spacer.gif" width="1" height="8" alt="" /><br />
<input type="button" name="ajax_hide" id="ajax_hide" value="Hide Dialog" style="border: solid 1px #00007f; background: #e0e0ff; color: blue; width: 6em;" onclick="javascript:onHideDlg();" />
</div></div>

<div id="disable_layer" style="display: none; position: fixed; width: 100%; height: 100%; top: 0px; left: 0px; background-color: gray; opacity: 0.4; filter: alpha(opacity=40);"></div>

<table cellpadding="0" cellspacing="0" id="server_stopped" style="display: none; position: fixed; width: 25em; height: 6em; top: 40%; left: 50%; margin-top: -3em; margin-left: -12.5em; border: solid 1px #00007f; background-color: #e7f0ff; text-align: center; vertical-align: middle; padding: 6px;"><tr><td>
<font size="+2" color="red"><b>Server is stopped</b></font>
</td></tr></table>

<table cellpadding="0" cellspacing="0" border="0" style="width: 50em;">
  <tr>
    <td valign="top" width="100%">
      <table cellpadding="0" cellspacing="0" border="0" width="100%">
        <tr>
          <td style="border: solid 1px #606090; background: #e0e0ff; text-align: center; font-size: large; padding: 0.3em;">Status</td>
        </tr>
        <tr>
          <td style="border: solid 1px #606090; border-top: none; vertical-align: top; padding: 10px;">
            <table class="main" cellpadding="2" cellspacing="2">
              <tr>
                <td style="width: 8em;">Server status:</td>
                <td style="width: 12.5em;" id="server_status">$serv_status</td>
                <td><input type="button" id="server_stop" style="width: 7.5em;" value="Stop server"$serv_stop_button /></td>
              </tr>
            </table>
            <br />
            <a href="/get.pl$log_file" target="_blank">View server log</a>
          </td>
        </tr>
      </table>
    </td>
<!--
    <td rowspan="3"><img src="images/environment-spacer.gif" width="20" height="1" border="0" alt="" /></td>
    <td rowspan="3" width="50%" valign="top">
      <table cellpadding="0" cellspacing="0" border="0" width="100%">
        <tr>
          <td style="border: solid 1px #606090; background: #e0e0ff; text-align: center; font-size: large; padding: 0.3em;">Settings</td>
        </tr>
        <tr>
          <td style="border: solid 1px #606090; border-top: none; vertical-align: top; padding: 10px;">
            Some setting here
          </td>
        </tr>
      </table>
    </td>
-->
  </tr>
  <tr>
    <td><img src="images/environment-spacer.gif" width="1" height="20" border="0" alt="" /></td>
  </tr>
  <tr>
    <td valign="top" width="100%">
      <table cellpadding="0" cellspacing="0" border="0" width="100%">
        <tr>
          <td style="border: solid 1px #606090; background: #e0e0ff; text-align: center; font-size: large; padding: 0.3em;">Distribution Data Management</td>
        </tr>
        <tr>
          <td style="border: solid 1px #606090; border-top: none; vertical-align: top; padding: 10px;">
DATA

my $checked_date_fmt = 'never';
my $dbver_current_fmt = 'not used';

print <<DATA;
            <b>Local distribution data snapshot:</b> <i><span id="curdbver">$dbver_current_fmt</span></i><br />
            <b>Last check performed at:</b> <i><span id="checked_date">$checked_date_fmt</span></i><br />
            <br />
            <input type="button" name="check_upd" id="check_upd" value="Check for updates" style="width: 12em;" onclick="javascript:onCheckDbUpdates();" /><br />
            <br />
            <span style="cursor: pointer;" onclick="javascript:showHideDetails();">&nbsp;<img src="images/arr_r.png" alt="" id="block_arrow_img" width="12" height="12" />&nbsp;&nbsp;Advanced</span>
            <div id="additional_data" style="border: dashed 1px gray; display: none; padding: 4px;">
              Proxy server for connecting to the Linux Foundation FTP:<br />
              <input type="text" name="proxy" id="proxy" value="$SERVER_PARAM{'PROXY'}" style="width: 35em;" onfocus="javascript:style.borderColor=input_border_color;" /><br />
              <br />
              <input type="button" name="apply_button" id="apply_button" value="Apply" style="width: 7em;" onclick="javascript:onSettingsApply();" />&nbsp;&nbsp;&nbsp;<input type="button" name="clear_button" id="clear_button" value="Clear" style="width: 7em;" onclick="javascript:onSettingsClear();" /><span id="conf_saved_msg" style="display: none;">&nbsp;&nbsp;&nbsp;<b>Configuration saved</b></span>
            </div>
          </td>
        </tr>
      </table>
    </td>
  </tr>
</table>

<script language="javascript" type="text/javascript">
// <![CDATA[
// Preload some images that are not initially visible
preload_images(new Array('expand.png', 'collapse.png', 'arr_d.png', 'ajax_progress.gif', 'progress.png'));
var input_border_color = ((navigator.appName == 'Konqueror') ? '#cccccc' : '');

// AJAX
// Additional initialization for the progress dialog
var progressDiv2 = document.getElementById('ajax_loading2');
if (progressDiv2) {
	if (navigator.appName == 'Microsoft Internet Explorer')
		progressDiv2.style.height = '9.5em';
}

var finished = true;
var elapsed_time = 0;
function updateTimer() {
	var elem = document.getElementById('timer');
	if (elem && !finished) {
		var m = Math.floor(elapsed_time / 60);
		var s = elapsed_time - m * 60;
		var tmp = '';
		tmp += (m < 10) ? '0' + m : m;
		tmp += ':';
		tmp += (s < 10) ? '0' + s : s;
		elem.innerHTML = tmp;
		++elapsed_time;
		setTimeout('updateTimer()', 1000);
	}
}

function onStopServer(pid, what) {
	if (!ajax_req_busy) {
		if (confirm('Do you really want to kill the process tree (PID: ' + pid + ')?')) {
			ajax_call_get('action=stop_tests&tree=' + what);
		}
	}
}

function onCheckDbUpdates() {
	if (!ajax_req_busy) {
		ajax_call_get('action=check_db_updates');
	}
}

function onHideDlg() {
	if (ajax_req_busy) {
		ajax_req.abort();
	}
	finished = true;
	timeout_show_progress = timeout_show_progress_save;
	progressDiv2.style.display = 'none';
}

function onSettingsApply() {
	if (!ajax_req_busy) {
		var elem = document.getElementById('proxy');
		if (!elem)
			return;
		if ((elem.value != '') && (elem.value.search(/^[A-Za-z0-9\\-_.]+:\\d+\$/) != 0)) {
			elem.style.borderColor = 'red';
			alert('Invalid format for proxy. Should be host:port.');
			return;
		}
		ajax_call_get('action=server_control&proxy=' + encodeURIComponent(elem.value));
	}
}

function onSettingsClear() {
	if (confirm('Are you sure you want to clear the settings?')) {
		var elem = document.getElementById('proxy');
		if (elem)
			elem.value = '';
	}
}

var timeout_show_progress_save;
function doDbUpdate() {
	if (!ajax_req_busy) {
		setProgress('db_upd_progress_bar_file', 0);
		setProgress('db_upd_progress_bar_total', 0);
		timeout_show_progress_save = timeout_show_progress;
		timeout_show_progress = -1;
		ajax_call_get('action=do_db_updates');
	}
}

function checkUpdateStatus() {
	if (finished)
		return;
	if (!ajax_req_busy) {
		ajax_call_get('action=check_db_update_status');
	}
}

function setProgress(id, percent) {
	var elem = document.getElementById(id);
	if (elem) {
		elem.style.display = ((percent == 0) ? 'none' : '');
		elem.alt = 'progress: ' + percent + '%';
		elem.width = percent * 4;
		// Fix for non-updating progress-bar in Konqueror
		if (elem.height) {		// But only when the image is already calculated and drawn
								// (else in IE it would shrink to 1px in height)
			elem.height -= 1;
			elem.height += 1;
		}
	}
}

function updateDates(xml_data) {
	if (xml_data.getElementsByTagName('curdbver').length > 0) {
		var curdbver = document.getElementById('curdbver');
		var curdbver_new = xml_data.getElementsByTagName('curdbver')[0].childNodes[0].nodeValue;
		if (curdbver.innerHTML != curdbver_new) {
			curdbver.innerHTML = curdbver_new;
			new fadeOut('curdbver', 255, 0, 0, 0, 0, 0, false);
		}
	}
	if (xml_data.getElementsByTagName('checked').length > 0) {
		var checked = document.getElementById('checked_date');
		var checked_new = xml_data.getElementsByTagName('checked')[0].childNodes[0].nodeValue;
		if (checked.innerHTML != checked_new) {
			checked.innerHTML = checked_new;
			new fadeOut('checked_date', 255, 0, 0, 0, 0, 0, false);
		}
	}
}

function ajaxProcessResult(responseXML) {
	if (responseXML.getElementsByTagName('stopped').length > 0) {
		var stopped = responseXML.getElementsByTagName('stopped')[0].childNodes[0].nodeValue;
		var what = responseXML.getElementsByTagName('stopped')[0].getAttribute('id');
		var server_status = document.getElementById('server_status');
		var server_stop = document.getElementById('server_stop');
		if (server_status && server_stop) {
			server_status.innerHTML = '<font color="red">Not running</font>';
			server_stop.disabled = true;
			var server_stopped = document.getElementById('server_stopped');
			server_stopped.style.display = '';
			var show_disable_layer = true;
			if (navigator.appName == 'Konqueror') {
				show_disable_layer = false;
			}
			else if (navigator.appName == 'Microsoft Internet Explorer') {
				var idx = navigator.appVersion.indexOf('MSIE ');
				if (idx == -1) {
					show_disable_layer = false;
				}
				else {
					if (navigator.appVersion.substr(idx + 5, 1) < '7')
						show_disable_layer = false;
				}
			}
			if (show_disable_layer)
				document.getElementById('disable_layer').style.display = '';
		}
	}
	else if (responseXML.getElementsByTagName('dbver').length > 0) {
		var dbver = responseXML.getElementsByTagName('dbver')[0].childNodes[0].nodeValue;
		if (dbver == 0) {
			alert('No updates available.');
			updateDates(responseXML);
		}
		else {
			var dbver_fmt = responseXML.getElementsByTagName('dbverfmt')[0].childNodes[0].nodeValue;
			if (confirm('New version available: ' + dbver_fmt + '\\nDo you want to update the snapshot now?'))
				doDbUpdate();
			else
				updateDates(responseXML);
		}
	}
	else if (responseXML.getElementsByTagName('updating').length > 0) {
		finished = false;
		progressDiv2.style.display = '';
		setTimeout('checkUpdateStatus()', 0);
		elapsed_time = 0;
		setTimeout("updateTimer()", 0);
	}
	else if (responseXML.getElementsByTagName('total').length > 0) {
		var total = responseXML.getElementsByTagName('total')[0].childNodes[0].nodeValue;
		if (total < 100) {
			var file = responseXML.getElementsByTagName('file')[0].childNodes[0].nodeValue;
			var filename = responseXML.getElementsByTagName('filename')[0].childNodes[0].nodeValue;
			document.getElementById('db_upd_filename').innerHTML = filename;
			setProgress('db_upd_progress_bar_file', file);
			setProgress('db_upd_progress_bar_total', total);
			setTimeout('checkUpdateStatus()', 500);
		}
		else {
			finished = true;
			timeout_show_progress = timeout_show_progress_save;
			progressDiv2.style.display = 'none';
			updateDates(responseXML);
		}
	}
	else if (responseXML.getElementsByTagName('serverupd').length > 0) {
		new fadeOut('conf_saved_msg', 0, 128, 0, 255, 255, 255, true);
	}
}
// ]]>
</script>
DATA

print_footer();
